/*
 *
 * Xilinx, Inc.
 * XILINX IS PROVIDING THIS DESIGN, CODE, OR INFORMATION "AS IS" AS A 
 * COURTESY TO YOU.  BY PROVIDING THIS DESIGN, CODE, OR INFORMATION AS
 * ONE POSSIBLE   IMPLEMENTATION OF THIS FEATURE, APPLICATION OR 
 * STANDARD, XILINX IS MAKING NO REPRESENTATION THAT THIS IMPLEMENTATION 
 * IS FREE FROM ANY CLAIMS OF INFRINGEMENT, AND YOU ARE RESPONSIBLE 
 * FOR OBTAINING ANY RIGHTS YOU MAY REQUIRE FOR YOUR IMPLEMENTATION
 * XILINX EXPRESSLY DISCLAIMS ANY WARRANTY WHATSOEVER WITH RESPECT TO 
 * THE ADEQUACY OF THE IMPLEMENTATION, INCLUDING BUT NOT LIMITED TO 
 * ANY WARRANTIES OR REPRESENTATIONS THAT THIS IMPLEMENTATION IS FREE 
 * FROM CLAIMS OF INFRINGEMENT, IMPLIED WARRANTIES OF MERCHANTABILITY 
 * AND FITNESS FOR A PARTICULAR PURPOSE..
 */

/*
 * Xilinx EDK 10.1.02 EDK_K_SP2.5
 *
 * This file is a sample test application
 *
 * This application is intended to test and/or illustrate some 
 * functionality of your system.  The contents of this file may
 * vary depending on the IP in your system and may use existing
 * IP driver functions.  These drivers will be generated in your
 * XPS project when you run the "Generate Libraries" menu item
 * in XPS.
 *
 */
 
#include "xparameters.h"
#include "xuartns550_l.h"
#include "../../sw/standalone/include/memory_map.h"
#include "xutil.h"
#include "xbasic_types.h"
#include "stdio.h"


// Assembly mnemonics
#define lqfcmx(rn, base, adr)    __asm__ __volatile__(\
                           "lqfcmx " #rn ",%0,%1\n"\
                           : : "b" (base), "r" (adr)\
                         )

#define stqfcmx(rn, base, adr)    __asm__ __volatile__(\
                                   "stqfcmx " #rn ",%0,%1\n"\
                                   : : "b" (base), "r" (adr)\
                                 )


// Data structures
volatile Xint32 __attribute__ ((aligned (32))) src[4] = {214,49,3,20};
volatile Xint32 __attribute__ ((aligned (32))) dst[4] = {-1,-1,-1,-1};
volatile Xint32 __attribute__ ((aligned (32))) src1[4] = {10,20,30,40};
volatile Xint32 __attribute__ ((aligned (32))) dst1[4] = {-1,-1,-1,-1};


//====================================================

int main (void) {
 
XUartNs550_SetBaud(UART_BASEADDR, UART_CLOCK,UART_BAUDRATE);
XUartNs550_mSetLineControlReg(UART_BASEADDR, XUN_LCR_8_DATA_BITS);


// Note!!: Comment out xil_printf statements for simulation!!!!
// xil_printf should only be used when running on the Hardware!!!
//  xil_printf("\r\nTesting FCM load and store\r\n");
//  xil_printf("Contents of dst, and dst1 before the load/store operations \r\n");
//  xil_printf("Original value of dst and dst1: \r\n");
//  xil_printf("    dst[0] = %d\r\n", dst[0]);
//  xil_printf("    dst[1] = %d\r\n", dst[1]);
//  xil_printf("    dst[2] = %d\r\n", dst[2]);
//  xil_printf("    dst[3] = %d\r\n", dst[3]); 
//  xil_printf("    dst1[0] = %d\r\n", dst1[0]);
//  xil_printf("    dst1[1] = %d\r\n", dst1[1]);
//  xil_printf("    dst1[2] = %d\r\n", dst1[2]);
//  xil_printf("    dst1[3] = %d\r\n", dst1[3]);  
  
  lqfcmx(2, src, 0); // load quad word from src[0] to FCM reg 2
  stqfcmx(2, dst, 0); // store quad word from FCM reg 2 to dst[0]
  
  lqfcmx(2, src1, 0); // load quad word from src1[0] to FCM reg 2
  stqfcmx(2, dst1, 0); // store quad word from FCM reg 2 to dst1[0]


  // Note!!!: comment out xil_printf statements for simulations!!!!
//  xil_printf("Contents of dst, and dst1 after the load/store \r\n");
//  xil_printf("Final value of dst: \r\n");
//  xil_printf("    dst[0] = %d\r\n", dst[0]);
//  xil_printf("    dst[1] = %d\r\n", dst[1]);
//  xil_printf("    dst[2] = %d\r\n", dst[2]);
//  xil_printf("    dst[3] = %d\r\n", dst[3]);  
//  xil_printf("    dst1[0] = %d\r\n", dst1[0]);
//  xil_printf("    dst1[1] = %d\r\n", dst1[1]);
//  xil_printf("    dst1[2] = %d\r\n", dst1[2]);
//  xil_printf("    dst1[3] = %d\r\n", dst1[3]);  
  
  
   return 0;
}

