/*
 * Copyright (c) 2008 Xilinx, Inc.  All rights reserved.
 *
 * Xilinx, Inc.
 * XILINX IS PROVIDING THIS DESIGN, CODE, OR INFORMATION "AS IS" AS A
 * COURTESY TO YOU.  BY PROVIDING THIS DESIGN, CODE, OR INFORMATION AS
 * ONE POSSIBLE   IMPLEMENTATION OF THIS FEATURE, APPLICATION OR
 * STANDARD, XILINX IS MAKING NO REPRESENTATION THAT THIS IMPLEMENTATION
 * IS FREE FROM ANY CLAIMS OF INFRINGEMENT, AND YOU ARE RESPONSIBLE
 * FOR OBTAINING ANY RIGHTS YOU MAY REQUIRE FOR YOUR IMPLEMENTATION.
 * XILINX EXPRESSLY DISCLAIMS ANY WARRANTY WHATSOEVER WITH RESPECT TO
 * THE ADEQUACY OF THE IMPLEMENTATION, INCLUDING BUT NOT LIMITED TO
 * ANY WARRANTIES OR REPRESENTATIONS THAT THIS IMPLEMENTATION IS FREE
 * FROM CLAIMS OF INFRINGEMENT, IMPLIED WARRANTIES OF MERCHANTABILITY
 * AND FITNESS FOR A PARTICULAR PURPOSE.
 *
 */
  
#include <stdio.h>
#include <string.h>
#include "xparameters.h"
#include "memory_map.h"

#include "xio.h"
#include "lwip/inet.h"
#include "lwip/sockets.h"
#include "lwipopts.h"


#define MAXBUFLEN 2000  // phjones
#define IMAGE_BASEADDR  (DDR_BASEADDR + 0x0A000000)
u16_t ECHO_PORT = 0xAE22;

void print_echo_app_header()
{
	xil_printf("\n\r-----lwIP echo server ------\n\r");
	xil_printf("You can connect to the echo server @ port %d\n\r", ECHO_PORT);
}

/* thread spawned for each connection */
void process_echo_request(int sd)
{
	int RECV_BUF_SIZE = 2048;
	unsigned char recv_buf[RECV_BUF_SIZE];
	int n, nwrote;

	xil_printf("echo server processing requests for sd: %d\n\r", sd);

	while (1) {
		/* read a max of RECV_BUF_SIZE bytes from socket */
		if ((n = read(sd, recv_buf, RECV_BUF_SIZE)) < 0) {
			xil_printf("%s: error reading from socket %d, closing socket\n\r", __FUNCTION__, sd);
			close(sd);
			return;
		}

		/* break if the recved message = "quit" */
		if (!strncmp(recv_buf, "quit", 4))
			break;

		/* handle request */
		if ((nwrote = write(sd, recv_buf, n)) < 0) {
			xil_printf("%s: ERROR responding too client echo request. recvlen = %d, respondlen = %d.\n\r", 
					__FUNCTION__, n, nwrote);
			xil_printf("Closing socket %d\n\r", sd);
			close(sd);
			return;
		}
	}
	
	/* close connection */
	close(sd);
}

void echo_application_thread()
{
	int addr_len; // phjones
	char buf[1920]; // phjones
	int payload_size; //phjones
	int sock, new_sd;
	struct sockaddr_in address, remote;
	struct sockaddr_in rv_addr;
	int size;

     // image variables
     int i;
     int j;
     int temp;
     unsigned int tftptr;
     int writeaddr;
     int baseaddr = IMAGE_BASEADDR;

  if ((sock = lwip_socket(AF_INET, SOCK_DGRAM, 0)) < 0)
      {
      	xil_printf("No socket \n");
		return;
      }

    xil_printf("Yes socket \n");
	address.sin_family = AF_INET;
	address.sin_port = htons(ECHO_PORT);
	address.sin_addr.s_addr = INADDR_ANY;

	if (lwip_bind(sock, (struct sockaddr *)&address, sizeof (address)) < 0)
	   {
	   	xil_printf("No bind \n");
		return;
	   }
	   
	   xil_printf("yes bind \n");
	   
	lwip_listen(sock, 5);

    xil_printf("yes listen \n");

	size = sizeof(remote);

	while (1) {
		
	  // Write a frame to memory
      for (j=0;j<480;j++) {
      addr_len = sizeof(struct sockaddr);
      
      // Get the first half of a row.
      if((payload_size = recvfrom(sock, buf, MAXBUFLEN, 0, (struct sockaddr *)&rv_addr, &addr_len)) < 0)
      {
      	xil_printf("recfrom error number %d \n", payload_size);
      	return;
      }
      
       // Get the 2nd half of a row
      if((payload_size = recvfrom(sock, buf+1000, MAXBUFLEN, 0, (struct sockaddr *)&rv_addr, &addr_len)) < 0)
      {
      	xil_printf("recfrom error number %d \n", payload_size);
      	return;
      }     
      //xil_printf("Got %d bytes \n",payload_size);
      
      
      // Send acknlowdgement back that have reived the row that was sent
	  if ((payload_size=sendto(sock, buf, 4, 0,(struct sockaddr *)&rv_addr, sizeof(struct sockaddr))) < 0)
     {
       xil_printf("sendto error number %d \n", payload_size);
       return;
     }
     //xil_printf("Sent %d bytes \n",payload_size);
     
     
      // Write a row to the frame buffer 
      for (i=0;i<640;i++) {
      	
        temp = ( (  ( (buf[i*3+2] << 8) | buf[(i*3)+1]) << 8) | buf[(i*3)]);
        //temp = 0x0000FF00;  // Debug: Paint screen GREEN
        writeaddr = baseaddr+(j*1024+i)*4;
        XIo_Out32(writeaddr, temp);
      }
    }
     
     // Update HW frame buffer pointer to display image to monitor
     tftptr = IMAGE_BASEADDR;
     XIo_Out32(TFT_BASEADDR, tftptr);
     xil_printf("Done writting frame \n");
		
	}
}
